using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace NeMech
{

    public class followCam: MVRScript
    {

		const string virsionMmsg = "=== followCam_S010F ===\nPC-Paid Content.\nRedistribution prohibited.\n(Please contact us)\nAlteration prohibited\nfollowCam_S010.cs Ver1.0 \nFor NeMech.S010.json(scene)\n\nCreated by NeMech in 2022/08\nModify by Nemech in 2022/08 \nhttps://www.patreon.com/nemech";
		private FreeControllerV3 cntAtom; // followTargetAtom position
		private Vector3 cntOldPos ;
        
        public override void Init()
        {

            try
            {
		        moveOn = new JSONStorableBool("moveOn", false, followCamToggleCallback);
		        RegisterBool(moveOn);
				moveCK = false;

				manualSwTrigger = new JSONStorableAction("followCam",followCamCallback);
				RegisterAction(manualSwTrigger);
				dbutton = CreateButton("followCam",false);
				if (dbutton != null) {
					dbutton.button.onClick.AddListener(followCamCallback);
				}

				jstring = new JSONStorableString("ContensMessage", virsionMmsg );
				dtext = CreateTextField(jstring);
				dtext.height=720f;
// 開発用
				moveInfoStr = new JSONStorableString("moveInfo", "" );
				dtext = CreateTextField(moveInfoStr,true);
				dtext.height=30f;


//				cntAtom = SuperController.singleton.GetAtomByUid("Bebad").GetStorableByID("control") as FreeControllerV3;
				cntAtom = containingAtom.GetStorableByID("control") as FreeControllerV3;
				cntOldPos = cntAtom.transform.localPosition;

				moveInfoStr.val = "moveOn: " + moveOn.val; // 開発用
             }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }

        }

		private JSONStorableString moveInfoStr; // 開発用;
		private JSONStorableString jstring;
		protected JSONStorableAction manualSwTrigger;
		private UIDynamicButton dbutton;
		private UIDynamicTextField dtext;
		private JSONStorableBool moveOn;
		private bool moveCK;

		private void followCamCallback() {
			cntOldPos = cntAtom.transform.localPosition;
			moveOn.val = !moveOn.val;
			moveInfoStr.val = "moveOn: " + moveOn.val; // 開発用
		}

		private void followCamToggleCallback(JSONStorableBool togglrSw) {
			cntOldPos = cntAtom.transform.localPosition;
			moveOn.val = togglrSw.val;
			moveInfoStr.val = "moveOn: " + moveOn.val; // 開発用
		}


		void Update() {
		
			if(moveOn.val == true && (( Vector3.zero != cntAtom.transform.localPosition - cntOldPos))){
				SuperController.singleton.navigationRig.transform.position = SuperController.singleton.navigationRig.transform.position + ( cntAtom.transform.localPosition - cntOldPos );
				cntOldPos = cntAtom.transform.localPosition;
			}
		}
	}
}
